%% Gewhnliche Differentialgleichungen erster Ordnung: einfache Beispiele
% Zu den Vorlesungsfolien der 8. Vorlesung 2022

%% Wie lautet die Differentialgleichung, welche Lsungen kennen Sie?
% die Differentialgleichung ist gegeben in der Form
% 
% $$y'=f(x,y)$$
% 

%%
% *Beispiel 3 der Folie:* 
%
% $$f(x,y) = xy/4 - 1$$ 
%
% Sie haben in den Mathematik-Vorlesungen gelernt, wie Sie die analytische
% Lsung finden: Lsung der homogenen Gleichung durch Trennung der
% Variablen; Finden einer partikulren Lsung mit Variation der Konstanten.
%
% Wenn Ihnen das zu mhsam erscheint, *fragen Sie MATLAB*:

%% Symbolische Lsung
syms y(x)                       % definiere symbolische Variable
dg = diff(y,x) == x*y/4-1;      % das ist die Differentialgleichung
lsg = dsolve(dg)                % dsolve lst 

%%
% *Mit Anfangsbedingung*
%
% Die allgemeine Lsung enthlt noch eine freie Konstante. Sie knnen eine
% Anfangsbedingung setzen:
lsg = dsolve(dg, y(0)==3)

%%
% Sie knnen den symbolischen Ausdruck in eine MATLAB-Funktion umwandeln
yfun = matlabFunction(lsg)
%%
% und wenn sie einen Funktionsgraph zeichnen wollen,...
fplot(yfun,[0 4])

%% Numerische Lsung
% Symbolische Lsungen gibt es nur in einfachen Fllen. In der Praxis sind
% Sie auf numerische Lsungen angewiesen. Definieren Sie $f$ als Funktion
% (mehrere Mglichkeiten; hier: anonymous function)
clear x y
f = @(x,y)  x*y/4-1;  

%%
% Rufen Sie einen DG-Lser auf. ode45 ist das Allzweck-Standard-Verfahren.
ode45(f,[0 4],3)

%%
% Das ist nur die einfachste Form des Aufrufs. Die bungen bieten dazu
% ausfhrlich Beispiele und Aufgaben.
